 /****************************************************************
 *       Copyright (C) 1988-1998, by Sybase, Inc.                *
 *       All rights reserved. No part of this software may be    *
 *       reproduced in any form or by any means - graphic,       *
 *       electronic or mechanical, including photocopying,       *
 *       recording, taping or information storage and retrieval  *
 *       systems - except with the written permission of         *
 *       Sybase, Inc.                                            *
 ****************************************************************/

#ifndef _SQLSTATE_H_INCLUDED
#define _SQLSTATE_H_INCLUDED
#define II_SQLSTATE

/**************************/
/* sql error return codes */
/**************************/

#define SQLSTATE_GENERIC_ERROR          SQLSTATE_ERROR

/*      Subtransaction Errors */

#define SQLSTATE_SUBTRANS_NOTFOUND                 "3B001"
#define SQLSTATE_SUBTRANS_REQUIRE_UNDO             "3BW01"


/*	Warnings */

#define SQLSTATE_NOERROR                           "00000"
#define SQLSTATE_NOTFOUND                          "02000"
#define SQLSTATE_TRUNCATED                         "01004"
#define SQLSTATE_TEMPORARY_TABLE                   "01W02"
#define SQLSTATE_CANNOT_CONVERT                    "01W03"
#define SQLSTATE_ROW_UPDATED_WARNING               "01W04"
#define SQLSTATE_PROCEDURE_COMPLETE                "01W05"
#define SQLSTATE_COLUMN_VALUE_CHANGED              "01W06"
#define SQLSTATE_CANNOT_EXECUTE_STMT               "01W08"
#define SQLSTATE_WARNING                           "01000"
#define SQLSTATE_HLI_MORE_DATA_AVAILABLE           "01WH1"
#define SQLSTATE_UNABLE_TO_START_ENGINE            "08W07"
#define SQLSTATE_INVALID_COMMAND_LINE              "08W08"
#define SQLSTATE_DATABASE_NOT_ACTIVE               "08W30"
#define SQLSTATE_START_STOP_DATABASE_DENIED        "08W29"
#define SQLSTATE_REQUEST_DENIED_NO_DATABASES       "08W28"
#define SQLSTATE_ALIAS_CLASH                       "08W27"
#define SQLSTATE_INVALID_LOCAL_OPTION              "08W25"
#define SQLSTATE_UNABLE_TO_START_DATABASE          "08W09"
#define SQLSTATE_DATABASE_NOT_FOUND                "08W10"
#define SQLSTATE_INVALID_DATABASE                  "08W11"
#define SQLSTATE_NO_DATABASE_FILE                  "08W39"
#define SQLSTATE_COMMUNICATIONS_ERROR              "08W12"
#define SQLSTATE_COMMUNICATIONS_UNDERFLOW          "08W31"
#define SQLSTATE_DYNAMIC_MEMORY_EXHAUSTED          "08W26"
#define SQLSTATE_NO_MEMORY                         "08W13"
#define SQLSTATE_DATABASE_NAME_REQUIRED            "08W14"
#define SQLSTATE_PROTOCOL_MISMATCH                 "08W15"
#define SQLSTATE_ENGINE_ALREADY_RUNNING            "08W23"
#define SQLSTATE_ENGINE_NOT_MULTIUSER              "08W16"
#define SQLSTATE_INVALID_PARAMETER                 "08W24"
#define SQLSTATE_PAGE_SIZE_TOO_BIG                 "08W22"
#define SQLSTATE_PAGE_SIZE_INVALID                 "08W32"
#define SQLSTATE_DATABASE_NOT_CREATED              "08W33"
#define SQLSTATE_AUTHENTICATION_VIOLATION          "08W21"
#define SQLSTATE_CONNECTIONS_DISABLED              "08W04"
#define SQLSTATE_ENGINE_NOT_RUNNING                "08W01"
#define SQLSTATE_NOT_CONNECTED                     "08003"
#define SQLSTATE_TOO_MANY_CONNECTIONS              "08W03"
#define SQLSTATE_INVALID_LOGON                     "28000"
#define SQLSTATE_INVALID_PASSWORD                  "28000"
#define SQLSTATE_INVALID_MODULE_LOGON              "28W01"
#define SQLSTATE_UNABLE_TO_CONNECT                 "08001"
#define SQLSTATE_CANNOT_OPEN_LOG                   "08W05"
#define SQLSTATE_ERROR_WRITING_LOG                 "08W17"
#define SQLSTATE_CONNECTION_NOT_FOUND              "08W02"
#define SQLSTATE_STILL_ACTIVE_CONNECTIONS          "08W06"
#define SQLSTATE_NAME_NOT_UNIQUE                   "52010"
#define SQLSTATE_INDEX_NAME_NOT_UNIQUE             "52W04"
#define SQLSTATE_EXISTING_PRIMARY_KEY              "55013"
#define SQLSTATE_INVALID_FOREIGN_KEY_DEF           "53030"
#define SQLSTATE_VIEW_DEFINITION_ERROR             "53011"
#define SQLSTATE_MUST_DROP_INDEX                   "55W01"
#define SQLSTATE_TABLE_MUST_BE_EMPTY               "55W02"
#define SQLSTATE_PRIMARY_KEY_REFERENCED            "52W99"
#define SQLSTATE_NO_PRIMARY_KEY                    "55008"
#define SQLSTATE_PRIMARY_KEY_COLUMN_DEFINED        "52009"
#define SQLSTATE_ALTER_CLAUSE_CONFLICT             "53W01"
#define SQLSTATE_PRIMARY_KEY_TWICE                 "52W05"
#define SQLSTATE_COLUMN_IN_INDEX                   "53W05"
#define SQLSTATE_USER_OWNS_TABLES                  "55W03"
#define SQLSTATE_IDENTIFIER_TOO_LONG               "54003"
#define SQLSTATE_DUPLICATE_FOREIGN_KEY             "52W06"
#define SQLSTATE_INDEX_NOT_FOUND                   "52W03"
#define SQLSTATE_MESSAGE_ALREADY_EXISTS            "52W16"
#define SQLSTATE_ALREADY_HAS_GRANT_PERMS           "42W01"
#define SQLSTATE_PERMISSION_DENIED                 "42501"
#define SQLSTATE_GROUP_CYCLE                       "42W02"
#define SQLSTATE_NOT_A_GROUP                       "42W03"
#define SQLSTATE_ALREADY_HAS_GROUP_MEMBERSHIP      "42W34"
#define SQLSTATE_INVALID_STATEMENT                 "07W02"
#define SQLSTATE_SYNTAX_ERROR                      "42W04"
#define SQLSTATE_IQ_PATH_SYNTAX_ERROR              "42W48"
#define SQLSTATE_STATEMENT_ERROR                   "26501"
#define SQLSTATE_INVALID_STATEMENT_TYPE            "07W03"
#define SQLSTATE_NOT_IMPLEMENTED                   "0A000"
#define SQLSTATE_TSQL_FEATURE_NOT_SUPPORTED        "0AW02"
#define SQLSTATE_LANGUAGE_EXTENSION                "0AW01"
#define SQLSTATE_STMT_NOT_ALLOWED_IN_PASSTHROUGH   "0AW05"
#define SQLSTATE_DBSPACE_NOT_FOUND                 "52W13"
#define SQLSTATE_CORRELATION_NAME_AMBIGUOUS        "52012"
#define SQLSTATE_UNKNOWN_USERID                    "08004"
#define SQLSTATE_TABLE_NOT_FOUND                   "42W33"
#define SQLSTATE_CORRELATION_NAME_NOT_FOUND        "52W02"
#define SQLSTATE_COLUMN_NOT_FOUND                  "52003"
#define SQLSTATE_COLUMN_AMBIGUOUS                  "52002"
#define SQLSTATE_FOREIGN_KEY_NAME_NOT_FOUND        "52W07"
#define SQLSTATE_CANNOT_JOIN                       "53W04"
#define SQLSTATE_AMBIGUOUS_JOIN                    "52W08"
#define SQLSTATE_OUTER_JOIN_CYCLE                  "52W14"
#define SQLSTATE_CANNOT_OUTER_JOIN                 "52W19"
#define SQLSTATE_CORRELATION_NAME_NEEDED           "52W15"
#define SQLSTATE_UNKNOWN_FUNC                      "42W05"
#define SQLSTATE_INVALID_GROUP_SELECT              "53003"
#define SQLSTATE_AGGREGATES_NOT_ALLOWED            "42W06"
#define SQLSTATE_SUBQUERY_SELECT_LIST              "53023"
#define SQLSTATE_INVALID_ORDER                     "53005"
#define SQLSTATE_INVALID_UNION                     "53026"
#define SQLSTATE_MESSAGE_NOT_FOUND                 "52W17"
#define SQLSTATE_USER_TYPE_NOT_FOUND               "52W18"
#define SQLSTATE_USER_OWNS_MESSAGES_OR_DATATYPES   "55W05"
#define SQLSTATE_WRONG_PARAMETER_COUNT             "37505"
#define SQLSTATE_INVALID_PARAMETER_NAME            "42W47"
#define SQLSTATE_VARIABLE_INVALID                  "42W07"
#define SQLSTATE_EXPRESSION_ERROR                  "42W08"
#define SQLSTATE_CONVERSION_ERROR                  "53018"
#define SQLSTATE_OVERFLOW_ERROR                    "22003"
#define SQLSTATE_INVALID_COLUMN_NUMBER             "42W13"
#define SQLSTATE_DESCRIBE_NONSELECT                "07005"
#define SQLSTATE_INVALID_DESCRIBE_TYPE             "07W01"
#define SQLSTATE_CURSOR_NOT_DECLARED               "24W01"
#define SQLSTATE_OPEN_CURSOR_ERROR                 "07003"
#define SQLSTATE_CURSOR_ALREADY_OPEN               "24502"
#define SQLSTATE_CURSOR_NOT_OPEN                   "24501"
#define SQLSTATE_NO_INDICATOR                      "22002"
#define SQLSTATE_SQLDA_TOO_SMALL                   "07002"
#define SQLSTATE_PUT_CURSOR_ERROR                  "09W01"
#define SQLSTATE_TOO_MANY_RECORDS                  "21000"
#define SQLSTATE_SUBQUERY_RESULT_NOT_UNIQUE        "21W01"
#define SQLSTATE_CURSOROP_NOT_ALLOWED              "09W02"
#define SQLSTATE_NOT_ENOUGH_HOST_VARS              "07001"
#define SQLSTATE_NOT_FOUND_IN_INDEX                "WI005"
#define SQLSTATE_NON_UPDATEABLE_COLUMN             "53W02"
#define SQLSTATE_CANNOT_MODIFY                     "42W32"
#define SQLSTATE_NON_UPDATEABLE_VIEW               "42W31"
#define SQLSTATE_PRIMARY_KEY_NOT_UNIQUE            "23W01"
#define SQLSTATE_INVALID_FOREIGN_KEY               "23503"
#define SQLSTATE_COLUMN_CANNOT_BE_NULL             "23502"
#define SQLSTATE_INDEX_NOT_UNIQUE                  "23505"
#define SQLSTATE_NO_CURRENT_ROW                    "24503"
#define SQLSTATE_PRIMARY_KEY_VALUE_REF             "23W05"
#define SQLSTATE_ONLY_ONE_TABLE                    "09W04"
#define SQLSTATE_INVALID_COLUMN_VALUE              "23506"
#define SQLSTATE_ROW_UPDATED_SINCE_READ            "22W02"
#define SQLSTATE_WRONG_NUM_OF_INSERT_COLS          "53002"
#define SQLSTATE_PRIMARY_KEY_MULTI_ROW_UPDATE      "21502"
#define SQLSTATE_PRIMARY_KEY_CURSOR_UPDATE         "56013"
#define SQLSTATE_DELETE_SUBQUERY_SAME_TABLE        "56014"
#define SQLSTATE_CURSOR_DELETE_SELF_REF            "09X02"
#define SQLSTATE_INSERT_SELF_REFERENCING           "21501"
#define SQLSTATE_VARIABLE_NOT_FOUND                "42W14"
#define SQLSTATE_VARIABLE_EXISTS                   "42W15"
#define SQLSTATE_LABEL_NOT_FOUND                   "42W24"
#define SQLSTATE_INVALID_FETCH_POSITION            "42W25"
#define SQLSTATE_WRONG_NUM_OF_FETCH_VARIABLES      "42W26"
#define SQLSTATE_PROCEDURE_NOT_FOUND               "52W09"
#define SQLSTATE_OLD_DBINIT                        "42W27"
#define SQLSTATE_ATOMIC_OPERATION                  "42W28"
#define SQLSTATE_TRIGGER_NOT_FOUND                 "52W10"
#define SQLSTATE_COLUMN_IN_TRIGGER                 "53W06"
#define SQLSTATE_USER_OWNS_PROCEDURES              "55W04"
#define SQLSTATE_TRIGGER_DEFN_CONFLICT             "52W11"
#define SQLSTATE_INVALID_TRIGGER_COL_REFS          "52W12"
#define SQLSTATE_INVALID_TRIGGER_STATEMENT         "2D501"
#define SQLSTATE_NESTING_TOO_DEEP                  "42W29"
#define SQLSTATE_PROCEDURES_NOT_IN_DESKTOP         "0AW04"
#define SQLSTATE_PUBLICATION_NOT_FOUND             "5RW01"
#define SQLSTATE_TABLE_HAS_PUBLICATIONS            "5RW02"
#define SQLSTATE_SUBSCRIPTION_NOT_UNIQUE           "5RW03"
#define SQLSTATE_SUBSCRIPTION_NOT_FOUND            "5RW04"
#define SQLSTATE_ONLY_ONE_PUBLISHER                "5RW05"
#define SQLSTATE_NOT_REMOTE_USER                   "5RW06"
#define SQLSTATE_NOT_REMOTE_TYPE                   "5RW07"
#define SQLSTATE_PASSTHROUGH_INCONSISTENT          "5RW08"
#define SQLSTATE_REMOTE_STATEMENT_FAILED           "5RW09"
#define SQLSTATE_CANNOT_UNIQUELY_IDENTIFY_ROWS     "09W05"
#define SQLSTATE_ERROR_NUMBER_OUT_OF_RANGE         "53W07"
#define SQLSTATE_INVALID_FORMAT_STRING_ARG_NUM     "53W08"
#define SQLSTATE_INVALID_OPTION                    "42W16"
#define SQLSTATE_INVALID_OPTION_SETTING            "42W17"
#define SQLSTATE_LOCKED                            "42W18"
#define SQLSTATE_MUST_BE_ONLY_CONNECTION           "42W19"
#define SQLSTATE_CHECKPOINT_REQUIRES_UNDO          "42W20"
#define SQLSTATE_TABLE_IN_USE                      "42W21"
#define SQLSTATE_PROCEDURE_IN_USE                  "42W23"
#define SQLSTATE_SAVEPOINT_NOTFOUND                "3B001"
#define SQLSTATE_ROLLBACK_NOT_ALLOWED              "3B002"
#define SQLSTATE_RESULT_NOT_ALLOWED                "3BW02"
#define SQLSTATE_SAVEPOINTS_REQUIRE_UNDO           "3BW01"
#define SQLSTATE_PP_DBLIB_MISMATCH                 "08W18"
#define SQLSTATE_DBLIB_ENGINE_MISMATCH             "08W19"
#define SQLSTATE_SERVER_ENGINE_MISMATCH            "08W20"
#define SQLSTATE_UNKNOWN_BACKUP_OPERATION          "WB001"
#define SQLSTATE_BACKUP_NOT_STARTED                "WB002"
#define SQLSTATE_BACKUP_CANNOT_RENAME_LOG_YET      "WB003"
#define SQLSTATE_BACKUP_UNABLE_TO_DELETE_FILE      "WB004"
#define SQLSTATE_LOG_TRUNCATED                     "WB005"
#define SQLSTATE_USER_DEFINED_EXCEPTION            "99999"
#define SQLSTATE_DOUBLE_REQUEST                    "42W22"
#define SQLSTATE_INTERRUPTED                       "57014"
#define SQLSTATE_ERROR                             "40000"
#define SQLSTATE_DATABASE_ERROR                    "40W01"
#define SQLSTATE_TERMINATED_BY_USER                "40W02"
#define SQLSTATE_DEVICE_FULL                       "40W03"
#define SQLSTATE_DEVICE_ERROR                      "40W04"
#define SQLSTATE_DEADLOCK                          "40001"
#define SQLSTATE_THREAD_DEADLOCK                   "40W06"
#define SQLSTATE_CONNECTION_TERMINATED             "40W07"
#define SQLSTATE_HLI_BAD_SYNTAX                    "42W11"
#define SQLSTATE_HLI_BAD_CURSOR                    "34W01"
#define SQLSTATE_HLI_BAD_STATEMENT                 "26W01"
#define SQLSTATE_HLI_BAD_HOST_VAR_NAME             "42W09"
#define SQLSTATE_HLI_BAD_HOST_VAR_VALUE            "42W10"
#define SQLSTATE_HLI_BAD_CALLBACK                  "42W12"
#define SQLSTATE_HLI_INTERNAL                      "WI007"
#define SQLSTATE_HLI_BAD_ARGUMENT                  "22W01"
#define SQLSTATE_BEYOND_EOF                        "WI001"
#define SQLSTATE_PHANTOM                           "WI002"
#define SQLSTATE_UNBLOCKED                         "WI003"
#define SQLSTATE_LOG_CORRUPTED                     "WI004"
#define SQLSTATE_UNSUPPORTED_LOAD_FORMAT           "WL001"
#define SQLSTATE_CANNOT_ACCESS_FILE                "WL002"
#define SQLSTATE_COLUMN_VALUE_TOO_LONG             "WL003"
#define SQLSTATE_CANNOT_UNLOAD_A_VIEW              "WL004"
#define SQLSTATE_DBSPACE_FULL                      "04W07"
#define SQLSTATE_ACCESS_BEYOND_END_OF_MAX_DBSPACE  "04W08"
#define SQLSTATE_PATTERN_TOO_LONG                  "WW001"
#define SQLSTATE_CANNOT_STOP_SERVER                "WW002"
#define SQLSTATE_INVALID_TEXTPTR_VALUE             "22W03"
#define SQLSTATE_INVALID_TEXT_IMAGE_DATATYPE       "53W09"
#define SQLSTATE_TOO_MANY_COLUMNS_IN_TABLE         "52W20"
#define SQLSTATE_EXTERNAL_CALLS_NOT_SUPPORTED      "WW003"
#define SQLSTATE_EXTERNAL_PLATFORM_FAILURE         "WW004"
#define SQLSTATE_REQUIRE_DLL_NAME                  "WW005"
#define SQLSTATE_COULD_NOT_LOAD_LIBRARY            "WW006"
#define SQLSTATE_COULD_NOT_FIND_FUNCTION           "WW007"
#define SQLSTATE_ERROR_CALLING_FUNCTION            "WW008"
#define SQLSTATE_DDL_NOT_ALLOWED_IN_PROCEDURES     "52W21"
#define SQLSTATE_DATATYPE_NOT_ALLOWED              "WW009"
#define SQLSTATE_TOO_MANY_PARAMETERS               "WW010"
#define SQLSTATE_THREAD_START_FAILURE              "WW011"
#define SQLSTATE_INVALID_SYNTAX_EXTENSION          "0AW03"
#define SQLSTATE_DIV_ZERO_ERROR                    "22012"
#define SQLSTATE_INVALID_ESCAPE_CHAR               "22019"
#define SQLSTATE_INVALID_ESCAPE_SEQ                "22025"
#define SQLSTATE_RAISERROR_STMT                    "WW012"
#define SQLSTATE_WITH_CHECK_OPTION_VIOLATION       "44000"
#define SQLSTATE_READ_ONLY_CURSOR                  "42W30"
#define SQLSTATE_UNTERMINATED_C_STR                "22024"
#define SQLSTATE_SYNTAX_EXTENSION_WARNING          "01W07"
#define SQLSTATE_CURSOR_OPERATION_CONFLICT         "01001"
#define SQLSTATE_NO_COLUMN_PERMS_FOR_VIEWS         "52W22"
#define SQLSTATE_NULL_VALUE_ELIMINATED             "01003"
#define SQLSTATE_DUPLICATE_REFERENCING_COLUMN      "42W40"
#define SQLSTATE_DUPLICATE_INSERT_COLUMN           "42W41"
#define SQLSTATE_STRING_RIGHT_TRUNCATION           "22001"
#define SQLSTATE_PARAMETER_NAME_MISSING            "42W42"
#define SQLSTATE_INVALID_DESCRIPTOR_INDEX          "07009"
#define SQLSTATE_ERROR_IN_ASSIGNMENT               "22005"
#define SQLSTATE_INVALID_DESCRIPTOR_NAME           "33000"
#define SQLSTATE_BACKUP_PAGE_INCOMPLETE            "01W10"
#define SQLSTATE_NO_DESCRIPTOR_DATA                "02W01"
#define SQLSTATE_NOT_PUBLIC_ID                     "42W43"
#define SQLSTATE_MORE_INFO                         "01W09"
#define SQLSTATE_TOO_MANY_COLUMNS_DELETED          "42W44"
#define SQLSTATE_TEMPORARY_NOT_ALLOWED             "42W45"
#define SQLSTATE_INVALID_OPTION_ON_CONNECT         "01W11"
#define SQLSTATE_OPTION_REQUIRES_DBA               "42W46"
#define SQLSTATE_INVALID_STANDARD_LOGON            "28W02"
#define SQLSTATE_INVALID_INTEGRATED_LOGON          "28W03"
#define SQLSTATE_INTEGRATED_LOGON_FAILED           "28W04"
#define SQLSTATE_PREEMPTED                         "WI006"
#define SQLSTATE_RETRY                             "WI008"
#define SQLSTATE_INTEGRATED_LOGON_UNSUPPORTED      "28W05"
#define SQLSTATE_INTEGRATED_LOGON_GUESTMAP         "28W06"
#define SQLSTATE_INTEGRATED_LOGON_SYSMAP           "28W07"
#define SQLSTATE_INTEGRATED_LOGON_MAPPED           "28W08"
#define SQLSTATE_INTEGRATED_LOGON_UNMAPPED         "28W09"
#define SQLSTATE_ARGUMENT_CANNOT_BE_NULL           "WP000"
#define SQLSTATE_UNHANDLED_JAVA_EXCEPTION          "WP001"
#define SQLSTATE_BAD_CLASS_FILE                    "WP002"
#define SQLSTATE_STORE_NOT_LOADED                  "08W34"
#define SQLSTATE_STORE_ENTRY_NOT_FOUND             "08W35"
#define SQLSTATE_STORE_VERSION_MISMATCH            "08W47"
#define SQLSTATE_INVALID_DBSPACE_FOR_CREATE        "08W36"
#define SQLSTATE_FIELD_NOT_FOUND                   "WW013"
#define SQLSTATE_INVALID_FIELD_REFERENCE           "WW014"
#define SQLSTATE_FIELD_CANNOT_BE_NULL              "WW015"
#define SQLSTATE_INVALID_INDEX_TYPE                "WW016"
#define SQLSTATE_DROP_DATABASE_FAILED              "WW017"
#define SQLSTATE_CANNOT_DECOMPRESS_CLASS           "WP003"
#define SQLSTATE_CLASS_MEMBER_OF_JAR               "WP004"
#define SQLSTATE_NO_PROFILE_FILE                   "08W37"
#define SQLSTATE_GEN_PARSE_ERROR                   "08W38"
#define SQLSTATE_OMNI_CONNECT_ERROR                "WO001"
#define SQLSTATE_OMNI_NO_RMT_OBJ                   "WO002"
#define SQLSTATE_OMNI_READONLY                     "WO003"
#define SQLSTATE_OMNI_SERVER_NOT_FOUND             "WO004"
#define SQLSTATE_OMNI_REMOTE_ERROR                 "WO005"
#define SQLSTATE_OMNI_BACKWARDS_CURSOR             "WO006"
#define SQLSTATE_JAVA_SERIALIZATION_ERROR          "WI009"
#define SQLSTATE_JAVA_DESERIALIZATION_ERROR        "WW018"
#define SQLSTATE_DATABASE_ACTIVE                   "08W40"
#define SQLSTATE_DATABASE_NEEDS_RECOVERY           "08W41"
#define SQLSTATE_OMNI_RMT_TABLE_NOTFOUND           "WO007"
#define SQLSTATE_OMNI_RMT_COLUMNS_NOTFOUND         "WO008"
#define SQLSTATE_NO_SCROLL_CURSOR                  "09W06"
#define SQLSTATE_METHOD_CANNOT_BE_CALLED           "WJ001"
#define SQLSTATE_BAD_CLASS_BYTE_CODE               "WP005"
#define SQLSTATE_PARAM_NOT_REGISTERED              "WJ002"
#define SQLSTATE_DATABASE_UPGRADE_FAILED           "08W42"
#define SQLSTATE_DATABASE_UPGRADE_NOT_POSSIBLE     "08W43"
#define SQLSTATE_INVALID_CURSOR_RANGE              "09W07"
#define SQLSTATE_JAVA_VM_NOT_STARTED               "WP006"
#define SQLSTATE_NO_COLUMN_NAME                    "52004"
#define SQLSTATE_INVALID_TRANSACTION_ISOLATION     "WJ003"
#define SQLSTATE_TABLE_HAS_REFACTION               "56001"
#define SQLSTATE_AMBIGUOUS_INDEX_NAME              "52W40"
#define SQLSTATE_OMNI_MEMORY_CONFIG                "WO009"
#define SQLSTATE_INVALID_TSQL_OJ_EXPRESSION        "52W23"
#define SQLSTATE_INVALID_TSQL_JOIN_TYPE            "52W24"
#define SQLSTATE_OMNI_DEBUG                        "WO010"
#define SQLSTATE_NAMESPACE_HEAP_EXHAUSTED          "WP007"
#define SQLSTATE_JAVA_VM_HEAP_EXHAUSTED            "WP008"
#define SQLSTATE_DUPLICATE_CURSOR_NAME             "WJ004"
#define SQLSTATE_ROLLBACK_ON_PREFETCH              "WW019"
#define SQLSTATE_RESOURCE_GOVERNOR_EXCEEDED        "WP009"
#define SQLSTATE_STATIC_REF_TO_NONSTATIC_VAR       "WW020"
#define SQLSTATE_UNSUPPORTED_CHARACTER_SET         "WW021"
#define SQLSTATE_BAD_PARAM_INDEX                   "WJ005"
#define SQLSTATE_RETVAL_CANNOT_BE_SET              "WJ006"
#define SQLSTATE_BACKUP_NOT_LOADED                 "08W44"
#define SQLSTATE_BACKUP_ENTRY_NOT_FOUND            "08W45"
#define SQLSTATE_UNSUPPORTED_JDBC_FEATURE          "WJ007"
#define SQLSTATE_CANNOT_CHANGE_OPENED_STATEMENT    "WJ008"
#define SQLSTATE_JDBC_OBJ_INTERNAL_ERR             "WJ009"
#define SQLSTATE_JDBC_OBJ_CLOSED                   "WJ010"
#define SQLSTATE_BACKUP_ERROR                      "08W46"
#define SQLSTATE_CANNOT_UPDATE_FINAL_FIELD         "WJ012"
#define SQLSTATE_SQLDA_INCONSISTENT                "07W04"
#define SQLSTATE_CANNOT_ACCESS_INSTANCE_MEMBER     "WJ011"
#define SQLSTATE_CANNOT_TRUNCATE_VIEW              "42W49"
#define SQLSTATE_CANNOT_INDEX_ON_JAVA_CLASS        "WW022"
#define SQLSTATE_COMPUTED_COLUMN_WRITE_ATTEMPTED   "WW023"
#define SQLSTATE_PROCEDURE_RETURNS_VOID            "53019"
#define SQLSTATE_TEXT_OPERATION_ON_VIEW            "42W50"
#define SQLSTATE_COMPUTED_COLUMNS_NOT_SUPPORTED    "0AW06"
#define SQLSTATE_INVALID_COMPARISON                "52W25"
#endif
